// @ts-check
import fs from "fs";
import grabDist from "./utils/grabDist";
import createMDX from "@next/mdx";

const distDir = grabDist();

/**
 * @type {import('next').NextConfig}
 */
const nextConfig = {
    reactStrictMode: true,
    eslint: {
        ignoreDuringBuilds: true,
    },
    typescript: {
        ignoreBuildErrors: true,
    },
    pageExtensions: ["js", "jsx", "ts", "tsx", "md", "mdx"],
    distDir,
};

const withMDX = createMDX({
    // Add markdown plugins here, as desired
});

export default withMDX(nextConfig);
